#ifndef _c400intime_H_
#define _c400intime_H_

#ifdef  c400intime_EXPORTS
#define c400intime_API __declspec(dllexport)
#else
#define c400intime_API __declspec(dllimport)
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rt.h>
#include <EhApi.h>

//----------------------------------------
// Define
//----------------------------------------
/** @enum ErrorCode
* @brief G[R[h
* @details G[R[h3ނAꂼ̃G[IDŏ4bitɎʃR[h^Ă܂B
* @details 0x8000 ... RSI-ECATAPĨG[IDB4bit(0x0000 - 0xFFFF)RSI-ECAT-Master̃G[R[hłBڍׂ"EH API HELP"mFB
* @details 0x4000 ... INtimeAPĨG[IDB4bit(0x0000 - 0xFFFF)INtime APĨG[R[hłBڍׂ"INtime SDK Help"mFB
* @details 0x0000 ... {CuAPĨG[IDB{CũG[R[hłBG[R[hꗗmFB
*/
enum ErrorCode {
	NO_ERROR = 0x00000000, //!< BG[ԁB

	ILLEGAL_PARAM_EHHANDLE = 0x00100101,	//!< APÏG[FEHHANDLE̒ls
	ILLEGAL_PARAM_AREA,			//!< APÏG[FGA̒ls
	ILLEGAL_PARAM_SLAVE,		//!< APÏG[FX[u̒ls
	ILLEGAL_PARAM_AXIS,			//!< APÏG[F̒ls
	ILLEGAL_PARAM_ACCDEC_RATE,	//!< [ǧvZʂs(͈͊O)
	ILLEGAL_PARAM_OTHER = 0x00100110,	//!< p[^̒ls(͈͊O)

	ILLEGAL_MEMORY_SHORTAGE = 0x00101000,	//!< s

	SLAVE_ERR_RESPONSE = 0x00200000,	//!< R}h݃G[(R}h[jOrbg(Bit56)True)

	FUNC_ERR_SEQUENCE = 0x00800000,		//!< APIŃG[
};

/** @enum ApiCode
* @brief APIʃR[h
* @details sĂAPI̎ʃR[hłB
*/
enum ApiCode {
	API_NONE = 0, //!< None

	// ݒ
	SET_CMD_PULSE = 101, //!< hic400_SetCmdPulse
	SET_ELS,		//!< hic400_SetEls
	SET_OLS,		//!< hic400_SetOls
	SET_ORG_MODE,	//!< hic400_SetOrgMode
	SET_SLS,		//!< hic400_SetSls
	SET_SVALM,		//!< hic400_SetSvAlm

	// ԓǏo
	READ_CTR = 201,	//!< hic400_ReadCtr
	READ_ERROR_STS,	//!< hic400_ReadErrorSts
	READ_EVENT_STS,	//!< hic400_ReadEventSts
	READ_SPD,		//!< hic400_ReadSpd
	R_REG,			//!< hic400_rReg
	R_PORT_W,		//!< hic400_rPortW

	// ݒ
	SET_ACC_RATE = 301,	//!< hic400_SetAccRate
	SET_AUX_SPD,	//!< hic400_SetAuxSpd
	SET_DEC_RATE,	//!< hic400_SetDecRate
	SET_EVENT_MASK,	//!< hic400_SetEventMask
	SET_FL_SPD,		//!< hic400_SetFLSpd
	SET_MULT,		//!< hic400_SetMult
	W_CMD_W,		//!< hic400_wCmdW
	W_REG,			//!< hic400_wReg
	W_PORT_W,		//!< hic400_wPortW

	// ^pݒ
	WRIT_CTR = 401,	//!< hic400_WritCtr
	WRIT_FH_SPD,	//!< hic400_WritFHSpd
	WRIT_OPE_MODE,	//!< hic400_WritOpeMode
	WRIT_POS,		//!< hic400_WritPos

	// 쐧w
	ACC_START = 501,//!< hic400_AccStart
	CNST_START_FH,	//!< hic400_CnstStartFH
	DEC_STOP,		//!< hic400_DecStop
	EMG_STOP,		//!< hic400_EmgStop

	// G[NA
	SYS_ERR_CLR = 601 //!< hic400_SysErrClr
};

//----------------------------------------
// Structure
//----------------------------------------
/** @struct SlaveRef
* @brief X[u\
* @details {CuAPI̐ɕKvȏ\̂łB 
*/
typedef struct {
	uint16_t slave;		//!< (Read)X[uԍm0 - n <br>hic400_GetSlaveInfosăX[uԍ擾܂B<br>CuAPIsɂ͂̔ԍɑΉX[us܂B
	uint16_t axis;		//!< (Write)gp鎲 [Bit3FUABit2FZABit1FYABit0FX] <br>gp鎲ɑΉrbg1ɂAPIR[܂B<br>APIɂĕΉĂ̂ƂȂ̂܂B
	uint16_t currentApi;//!< (Read)ݎsAPIʃR[h
	uint8_t status;		//!< (Read)API [0x00:sA0x01:ݒA0x10:݊Es҂A0xff:G[]
} SlaveRef;

//----------------------------------------
// C400 INtime API
//----------------------------------------
/** @fn uint32_t hic400_wCmdW(SlaveRef* pSlv, uint16_t wCmd)
* @brief R}h
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) R}hf[^
* @return G[R[h
* @details w肵X[uюցAR}h݂܂BR}h̓éAHES-C400[U[Y}jA<^p>AR}h̍ڂQƂB
*/
c400intime_API uint32_t hic400_wCmdW(SlaveRef* pSlv, uint16_t wCmd);

/** @fn uint32_t hic400_wReg(SlaveRef* pSlv, uint16_t wCmd, uint32_t dwReg)
* @brief WX^
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) WX^ǂݏo^݃R}h
* @param (uint32_t) WX^݃f[^
* @return G[R[h
* @details w肵X[uюցAPCLWX^f[^݂܂BPCLWX^̓éAHES-C400[U[Y}jA<^p>AWX^R}h̍ڂQƂB
*/
c400intime_API uint32_t hic400_wReg(SlaveRef* pSlv, uint16_t wCmd, uint32_t dwReg);

/** @fn uint32_t hic400_rReg(SlaveRef* pSlv, uint16_t wCmd, uint32_t* dwReg)
* @brief WX^Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t*) WX^ǂݏo^݃R}h
* @param (uint32_t*) WX^ǂݏof[^̊i[ꏊAhX
* @return G[R[h
* @details w肵X[uюPCLWX^eǂݏoi[܂B
* @details PCLWX^̓éAHES-C400[U[Y}jA<^p>AWX^R}h̍ڂQƂB
*/
c400intime_API uint32_t hic400_rReg(SlaveRef* pSlv, uint16_t wCmd, uint32_t* dwReg);

/** @fn uint32_t hic400_wPortW(SlaveRef* pSlv, uint8_t port, uint16_t wData)
* @brief IvV|[g̏
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint8_t) ݃IvV|[g
* @param (uint16_t) IvV|[g݃f[^
* @return G[R[h
* @details w肵X[uю̎wIvV|[gցAf[^݂܂B
* @details IvV|[g̓éAC400[U[Y}jA<\tgEFA>AIvV|[g̍ڂQƂB
*/
c400intime_API uint32_t hic400_wPortW(SlaveRef* pSlv, uint8_t port, uint16_t wData);

/** @fn uint32_t hic400_rPortW(SlaveRef* pSlv, uint8_t port, uint16_t* wData)
* @brief IvV|[g̓ǂݏo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint8_t) ǂݏoIvV|[g
* @param (uint16_t*) IvV|[gǂݏof[^̊i[ꏊAhX
* @return G[R[h
* @details w肵X[uю̎wIvV|[g̓eǂݏoAwꏊɊi[܂B
* @details IvV|[g̓éAHES-C400[U[Y}jA<\tgEFA>AIvV|[g̍ڂQƂB
*/
c400intime_API uint32_t hic400_rPortW(SlaveRef* pSlv, uint8_t port, uint16_t* wData);

/** @fn uint32_t hic400_SysErrClr(SlaveRef* pSlv, uint32_t rstbit)
* @brief G[NA
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) Zbgʒuw
* @return G[R[h
* @details w肵X[uɂāAPDO Inputsf[^G[Xe[^Xf[^̃G[E[jONA܂B
* @details Zbgʒuw̃rbgATC<br>Bit0 : X[uG[NArbg <br>Bit1 : X[u[jONArbg
* @details R}h݈̏ȊOŔG[NA܂BNAɂ̓NArbgIɃZbg܂B
* @details G[ǂݏoɂ́Ahic400_ReadSysErrgp܂BG[Xe[^X̓éAHES-C400[U[Y}jA<^p>AG[Xe[^X(REST)̍ڂQƂB
* @details R}h݂Ŗ肪ꍇAX[u\̂APIԂErrorɂȂ܂ÃR}hɎsƎIɃNA܂B̂߁AR}h̏݃G[ɂAPIR[Kv͂܂B
*/
c400intime_API uint32_t hic400_SysErrClr(SlaveRef* pSlv, uint32_t rstbit);

/** @fn uint32_t hic400_SetCmdPulse(SlaveRef* pSlv, uint16_t cmdpls)
* @brief w߃pX̏o͌`̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) w߃pX̏o͌`
* @return G[R[h
* @details w肵X[uю̕΍JE^NAo͂ݒ肵܂B
* @details w߃pX̏o͌`<br>0FʃpX<br>1FʃpX<br>2Fʑ(Bi)<br>3Fʑ(Ai)
*/
c400intime_API uint32_t hic400_SetCmdPulse(SlaveRef* pSlv, uint16_t cmdpls);

/** @fn uint32_t hic400_SetEls(SlaveRef* pSlv, uint16_t pdis, uint16_t mdis, uint16_t pol, uint16_t stop)
* @brief ELS̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) +ELS̗L/ [0 : LA1 : ]
* @param (uint16_t) -ELS̗L/ [0 : LA1 : ]
* @param (uint16_t) ɐ̑I [0 : BځA1 : A]
* @param (uint16_t) ~@m0 : ~A1 : ~n
* @return G[R[h
* @details w肵X[uюELS͗L/AɐуZTL̒~@ݒ肵܂B
* @details ɐAڂɂāA}ELŜꂩ𖳌@Ƃݒ͂ł܂Bp[^G[ԋp܂B
*/
c400intime_API uint32_t hic400_SetEls(SlaveRef* pSlv, uint16_t pdis, uint16_t mdis, uint16_t pol, uint16_t stop);

/** @fn uint32_t hic400_SetOls(SlaveRef* pSlv, uint16_t pol)
* @brief OLS̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) ɐ̑I [0 : BځA1 : A]
* @return G[R[h
* @details w肵X[uюOLS͋ɐݒ肵܂B
*/
c400intime_API uint32_t hic400_SetOls(SlaveRef* pSlv, uint16_t pol);

/** @fn uint32_t hic400_SetOrgMode(SlaveRef* pSlv, uint16_t mode)
* @brief _A[h̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) _A[h [0 - 12]
* @return G[R[h
* @details w肵X[uю̌_Aݒ肵܂B<br>[hɂĂ̏ڍׂ́AC400[U[Y}jA<^p>A_A (ORGmode)̍ڂQƂB<br>
* @details _A[h9-12ɂ
* @details [h9-12ł́ACTR2ɂ_As܂ACTR2͏ݒ"00 : ENC"ɂȂĂ܂B
* @details ENC͂̂ȂhCog̏ꍇ́Aݒ背WX^3(RENV3)CTR2IP(Bit9-8) "01 : w߃pX" WX^݂Ă炲gpB
* @details _A̓éAHES-C400[U[Y}jA<^p>A_A(ORGmode)̍ڂQƂB
*/
c400intime_API uint32_t hic400_SetOrgMode(SlaveRef* pSlv, uint16_t mode);

/** @fn uint32_t hic400_SetSls(SlaveRef* pSlv, int32_t psls, int32_t msls, uint16_t enable, uint16_t stop)
* @brief \tg~bg̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (int32_t) +SLS̃~bgpX[-134217728 - +134217727]
* @param (int32_t) -SLS̃~bgpX[-134217728 - +134217727]
* @param (uint16_t) \tg~bg̎gpm0 : sgpA1 : gpn
* @param (uint16_t) ~@m0 : ~A1 : ~n
* @return G[R[h
* @details w肵X[uю̃\tg~bggpۂƒ~@ݒ肵܂B
* @details \tg~bggp+SLS͕K-SLS傫ĉB
* @details \tg~bgsgp͏ݒ莞(msls = psls = enable = 0)ɂȂ܂B
*/
c400intime_API uint32_t hic400_SetSls(SlaveRef* pSlv, int32_t psls, int32_t msls, uint16_t enable, uint16_t stop);

/** @fn uint32_t hic400_SetSvAlm(SlaveRef* pSlv, uint16_t pol, uint16_t stop)
* @brief SVALM̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) ɐ̑I [0 : BځA1 : A]
* @param (uint16_t) ~@   [0 : ~A1 : ~]
* @return G[R[h
* @details w肵X[uюSVALM͋ɐƒ~@ݒ肵܂B
*/
c400intime_API uint32_t hic400_SetSvAlm(SlaveRef* pSlv, uint16_t pol, uint16_t stop);

/** @fn uint32_t hic400_SetAccRate(SlaveRef* pSlv, uint32_t rate)
* @brief [g̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) [g[1 - 65535]
* @return G[R[h
* @details w肵X[uю̉[gݒ肵܂B
*/
c400intime_API uint32_t hic400_SetAccRate(SlaveRef* pSlv, uint32_t rate);

/** @fn uint32_t hic400_SetAuxSpd(SlaveRef* pSlv, uint32_t spd)
* @brief ⏕x̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) ⏕x(FA)f[^[1 - 65535]
* @return G[R[h
* @details w肵X[uю̕⏕xݒ肵܂B
*/
c400intime_API uint32_t hic400_SetAuxSpd(SlaveRef* pSlv, uint32_t spd);

/** @fn uint32_t hic400_SetDecRate(SlaveRef* pSlv, uint32_t rate)
* @brief [g̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) [g[1 - 65535]
* @return G[R[h
* @details w肵X[uю̌[gݒ肵܂B
*/
c400intime_API uint32_t hic400_SetDecRate(SlaveRef* pSlv, uint32_t rate);

/** @fn uint32_t hic400_SetEventMask(SlaveRef* pSlv, uint32_t mask)
* @brief Cxg}XN̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) Cxg}XNf[^ [0 - 0x0007ffff]
* @return G[R[h
* @details w肵X[uю̃Cxg}XN(RIRQ)ݒ肵܂B
* @details CxgXe[^X(RIST)̓éAHES-C400[U[Y}jA<^p>ACxgXe[^X(RIST)̍ڂQƂB
*/
c400intime_API uint32_t hic400_SetEventMask(SlaveRef* pSlv, uint32_t mask);

/** @fn uint32_t hic400_SetFLSpd(SlaveRef* pSlv, uint32_t spd)
* @brief x[Xx̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) x[Xx(FL)f[^ [1 - 65535]
* @return G[R[h
* @details w肵X[uю̃x[Xxݒ肵܂B
*/
c400intime_API uint32_t hic400_SetFLSpd(SlaveRef* pSlv, uint32_t spd);

/** @fn uint32_t hic400_SetMult(SlaveRef* pSlv, uint32_t rmg)
* @brief {ݒliMGj̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) {ݒl [2 - 4095]
* @return G[R[h
* @details w肵X[uю̑x̑x{(RMG)ݒ肵܂B
* @details x{(RMG)̓éAHES-C400[U[Y}jA<^p>AxƉx̍ڂQƂB
*/
c400intime_API uint32_t hic400_SetMult(SlaveRef* pSlv, uint32_t rmg);

/** @fn uint32_t hic400_WritCtr(SlaveRef* pSlv, int32_t preset, uint16_t selctr)
* @brief JE^vZbg
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) vZbgl (JE^ɂē͉\ȒlقȂ܂B)
* @param (uint16_t) JE^I [1 : JE^1A2 : JE^2A3 : JE^3A4 : JE^4]
* @return G[R[h
* @details w肵X[uю̃JE^vZbg܂B
* @details vZbgl͈̔͂́ACTR1ECTR2ECTR4͕28bit(-134217728 - +134217727)
* @details CTR3͕16bit(-32768 - +32767)łB<br>͈͂𒴂ƃp[^G[ƂȂ܂B
*/
c400intime_API uint32_t hic400_WritCtr(SlaveRef* pSlv, int32_t preset, uint16_t selctr);

/** @fn uint32_t hic400_WritFHSpd(SlaveRef* pSlv, uint32_t spd)
* @brief 쑬x̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t) FHi쑬xjWX^l
* @return G[R[h
* @details w肵X[uю̓쑬xݒ肵܂B
*/
c400intime_API uint32_t hic400_WritFHSpd(SlaveRef* pSlv, uint32_t spd);

/** @fn uint32_t hic400_WritOpeMode(SlaveRef* pSlv, uint16_t mode)
* @brief 샂[h̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) 샂[h
* @return G[R[h
* @details w肵X[uю̓샂[hݒ肵܂B܂A샂[hłȂA샂[hWX^̐ݒɍs܂B
* @details ޓ샂[hWX^ݒl : 0x0EF3A700 (8rbg샂[hɑΉ)@  A샂[h42ĥƂ́A0x0EF3E700(PCSL)<br>
* @details Ή샂[hꗗ (샂[h̏ڍׂ́AHES-C400[U[Y}jA<^p>A샂[h(MOD)̍ڂQƂB)
* @details EA<br>00h : +AA08h : -A<br>
* @details Eʒu<br>41h : ʒuߓ(ړʎw)A42h : PCSʒuߓA44h : w߈ʒu0_AA45h : @Bʒu0_AA46h : +1pXA4eh : -1pXA47h : ^C}<br>
* @details E<br>60h : ԘAA61h : ԁA62h : 2PCLԂ̒ԘAA63h : 2PCLԂ̒ԁA64h : CW~ʕԁA65h : CCW~ʕ<br>
* @details E_A<br>10h : +_AA18h : -_AA12h : +_oA1Ah : -_oA15h : +_T[`A1Dh : -_T[`<br>
* @details EELSESLS<br>20h : +ELS܂+SLSʒu܂œA28h : -ELS܂-SLSʒu܂œA22h : +ELS܂+SLSoA2Ah : -ELS܂-SLSo<br>
* @details EZ܂ňړ<br>24h : +ZJEgA2Ch : -ZJEg<br>
* @details Enh<br>01h : pT͂ɂAA51h : pT͂ɂʒuߓA54h : pT͂ɂw߈ʒu0_AA55h : pT͂ɂ@Bʒu0_A<br>
* @details EJOG<br>02h : }DR͂ɂAA56h : }DR͂ɂʒuߓ
*/
c400intime_API uint32_t hic400_WritOpeMode(SlaveRef* pSlv, uint16_t mode);

/** @fn uint32_t hic400_WritPos(SlaveRef* pSlv, int32_t distnc)
* @brief ʒu߈ړʂ̐ݒ
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (int32_t) ړ
* @return G[R[h
* @details w肵X[uю̈ʒu߈ړʂݒ肵܂B
*/
c400intime_API uint32_t hic400_WritPos(SlaveRef* pSlv, int32_t distnc);

/** @fn uint32_t hic400_ReadCtr(SlaveRef* pSlv, uint16_t selctr, int32_t* count)
* @brief JE^̓Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t) JE^I [1 : CTR1A2 : CTR2A3 : CTR3A4 : CTR4]
* @param (int32_t*) ǂݏof[^i[AhX
* @return G[R[h
* @details w肵X[uю̃JE^lǂݏoAw肵AhXɊi[܂B
* @details CTR1 : w߃pXóACTR2 : GR[_́ACTR3 : ΍JE^(Eop)ACTR4 : ėpJE^(w߃pXEGR[_͓)
*/
c400intime_API uint32_t hic400_ReadCtr(SlaveRef* pSlv, uint16_t selctr, int32_t* count);

/** @fn uint32_t hic400_ReadEventSts(SlaveRef* pSlv, uint32_t* ists)
* @brief CxgXe[^X̓Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t*) ǂݏof[^i[AhX
* @return G[R[h
* @details w肵X[uю̃CxgXe[^XǂݏoAw肵AhXɊi[܂B
* @details CxgXe[^X̓éAC400[U[Y}jA<^p>ACxgXe[^X(RIST)̍ڂQƂB
*/
c400intime_API uint32_t hic400_ReadEventSts(SlaveRef* pSlv, uint32_t* ists);

/** @fn uint32_t hic400_ReadSpd(SlaveRef* pSlv, uint16_t* spd)
* @brief wߑx̓Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t*) ǂݏof[^i[AhX
* @return G[R[h
* @details w肵X[uю̎wߑxǂݏoAw肵AhXɊi[܂B
*/
c400intime_API uint32_t hic400_ReadSpd(SlaveRef* pSlv, uint16_t* spd);

/** @fn uint32_t hic400_ReadErrorSts(SlaveRef* pSlv, uint32_t* ests)
* @brief G[Xe[^X̓Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint32_t*) Ǐoꂽf[^i[GÃAhX
* @return G[R[h
* @details w肵X[uю̃G[Xe[^XǂݏoAw肳ꂽAhXɊi[܂BG[Xe[^X̓éAHES-C400[U[Y}jA<^p>AG[Xe[^X(REST)̍ڂQƂB
*/
c400intime_API uint32_t hic400_ReadErrorSts(SlaveRef* pSlv, uint32_t* ests);

/** @fn uint32_t hic400_AccStart(SlaveRef* pSlv)
* @brief X^[g
* @param (SlaveRef*) X[ui[\̂̃|C^
* @return G[R[h
* @details w肵X[u̕ɑ΂ēɉX^[gs܂B
*/
c400intime_API uint32_t hic400_AccStart(SlaveRef* pSlv);

/** @fn uint32_t hic400_CnstStartFH(SlaveRef* pSlv)
* @brief FH葬X^[g
* @param (SlaveRef*) X[ui[\̂̃|C^
* @return G[R[h
* @details w肵X[u̕ɑ΂ēFH葬X^[gs܂B
*/
c400intime_API uint32_t hic400_CnstStartFH(SlaveRef* pSlv);

/** @fn uint32_t hic400_DecStop(SlaveRef* pSlv)
* @brief ~
* @param (SlaveRef*) X[ui[\̂̃|C^
* @return G[R[h
* @details w肵X[u̕ɑ΂ēɌ~s܂B
*/
c400intime_API uint32_t hic400_DecStop(SlaveRef* pSlv);

/** @fn uint32_t hic400_EmgStop(SlaveRef* pSlv)
* @brief ~
* @param (SlaveRef*) X[ui[\̂̃|C^
* @return G[R[h
* @details w肵X[u̕ɑ΂ēɔ~s܂B
*/
c400intime_API uint32_t hic400_EmgStop(SlaveRef* pSlv);

/** @fn uint32_t hic400_ReadMainSts(SlaveRef* pSlv, uint16_t* msts)
* @brief CXe[^X̓Ǐo(PDOǂݍ)
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t*) Ǐoꂽf[^i[GÃAhX
* @return G[R[h
* @details w肵X[uю̃CXe[^XǂݏoAw肳ꂽAhXɊi[܂BCXe[^X̓éAHES-C400[U[Y}jA<^p>ACXe[^X(MSTS)̍ڂQƂB
* @details APIPDOǂݍ݂słAPCLւ̃CXe[^XǂݏoR}h݂͍s܂B
* @details ܂AAPI̎sɃX[u\̂̃JgAPIƂ̃Xe[g͕ω܂(łĂяoƂł܂)B
*/
c400intime_API uint32_t hic400_ReadMainSts(SlaveRef* pSlv, uint16_t* msts);

/** @fn uint32_t hic400_ReadSubSts(SlaveRef* pSlv, uint16_t* ssts)
* @brief TuXe[^X̓Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t*) Ǐoꂽf[^i[GÃAhX
* @return G[R[h
* @details w肵X[uю̃TuXe[^XǂݏoAw肳ꂽAhXɊi[܂BTuXe[^X̓éAHES-C400[U[Y}jA<^p>ATuXe[^X(SSTS)̍ڂQƂB
* @details APIPDOǂݍ݂słAPCLւ̃TuXe[^XǂݏoR}h݂͍s܂B
* @details ܂AAPI̎sɃX[u\̂̃JgAPIƂ̃Xe[g͕ω܂(łĂяoƂł܂)B
*/
c400intime_API uint32_t hic400_ReadSubSts(SlaveRef* pSlv, uint16_t* msts);

/** @fn uint32_t hic400_ReadSysErr(SlaveRef* pSlv, uint16_t* syse)
* @brief G[Xe[^X̓Ǐo
* @param (SlaveRef*) X[ui[\̂̃|C^
* @param (uint16_t*) Ǐoꂽf[^i[GÃAhX
* @return G[R[h
* @details w肵X[ũG[Xe[^XǂݏoAw肳ꂽAhXɊi[܂B
* @details G[Xe[^X́AX[uG[Xe[^Xf[^(Index:SubIndex = 6000h:17)ǂݍł܂BG[éAHES-C400[U[Y}jA<\tgEFA>AG[Xe[^Xf[^̍ڂQƂB
* @details G[hic400_SysErrClrŃNA܂B
*/
c400intime_API uint32_t hic400_ReadSysErr(SlaveRef* pSlv, uint16_t* syse);

/** @fn uint32_t hic400_CalAccRate(uint32_t* rate, uint32_t dwtime, uint32_t fh, uint32_t fl, uint16_t profile, uint32_t ssection)
* @brief [gvZ
* @param (uint32_t*) vZʂi[ϐ̃|C^
* @param (uint32_t) [msec]
* @param (uint32_t) FHWX^l [1 - 65535]
* @param (uint32_t) FLWX^l [1 - 65535]
* @param (uint16_t) vt@Č`I [0 : A1 : S]
* @param (uint32_t) S(Sł͒l)  ssection = (FH - FL) / 2 ̏ꍇ͒ȂɂȂ܂B
* @return G[R[h
* @details ԁCFHCFL [gvZCw肵AhXɊi[܂B
* @details S(RUS) = S(RDS) ŌvZ܂B
* @details vt@Č`I(profile=0)̂ƂASԂɒlꍇ(ssection != 0)AG[ƂȂ܂B
* @details ܂AAPI̎sɃX[u\̂̃JgAPIƂ̃Xe[g͕ω܂(łĂяoƂł܂)B
*/
c400intime_API uint32_t hic400_CalAccRate(uint32_t* rate, uint32_t dwtime, uint32_t fh, uint32_t fl, uint16_t profile, uint32_t ssection);

/** @fn uint32_t hic400_GetSlaveInfo(EHHANDLE ehHandle, uint32_t Instance, SlaveRef* pSlv)
* @brief X[u̎擾
* @param (EHHANDLE) EtherCATʐMAPIΘbnh
* @param (uint32_t) CX^Xԍ[0 - ]
* @param (uint16_t*) X[ui[\̂̃|C^
* @return G[R[h
* @details CX^Xԍ́AC400̃}X^̐ڑłB1ԍŏC400̃CX^Xԍ0A2Ԗڂ1A3Ԗڂ2A...B
* @details APIR[ďɊƁAX[u\SlaveRef̃oslaveɃX[uԍi[܂B
* @details {CuAPÍAAPIŎ擾X[uԍƎ̎wăR[܂B
* @details ܂AAPI̎sɃX[u\̂̃JgAPIƂ̃Xe[g͕ω܂B
*/
c400intime_API uint32_t hic400_GetSlaveInfo(EHHANDLE ehHandle, uint32_t Instance, SlaveRef* pSlv);

/** @fn uint32_t hic400_rPdo(EHHANDLE ehHandle)
* @brief PDOf[^(INFC400}X^)ǂݍ
* @param (EHHANDLE) EtherCATʐMAPIΘbnh
* @return G[R[h
* @details hic400_GetAxisInfo()œo^PDOf[^(INFC400}X^)ǂݍ݂܂BPDOf[^(INFC400}X^)̓éAHES-C400[U[Y}jA<\tgEFA>APDO Inputsf[^̍ڂQƂB
* @details C400APIgpĂTCNbN̈ԍŏŕK{APIR[ĂB
* @details ܂AAPI̎sɃX[u\̂̃JgAPIƂ̃Xe[g͕ω܂B
*/
c400intime_API uint32_t hic400_rPdo(EHHANDLE ehHandle);

/** @fn uint32_t hic400_wPdo(EHHANDLE ehHandle)
* @brief PDOf[^(OUTF}X^C400)
* @param (EHHANDLE) EtherCATʐMAPIΘbnh
* @return G[R[h
* @details hic400_GetAxisInfo()œo^PDOf[^(OUTF}X^C400)݂܂BPDOf[^(OUTF}X^C400)̓éAHES-C400[U[Y}jA<\tgEFA>APDO Outputsf[^̍ڂQƂB
* @details C400APIgpĂTCNbN̈ԍŌŕK{APIR[ĂB
* @details ܂AAPI̎sɃX[u\̂̃JgAPIƂ̃Xe[g͕ω܂B
*/
c400intime_API uint32_t hic400_wPdo(EHHANDLE ehHandle);

#endif
