/*****************************************************************************
* FILE NAME:    INtimeTest.c - CvOW[
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <rt.h>

#include "INtimeTest.h"

// O[oϐ
RTHANDLE			hRootProcess;
DWORD				dwKtickInUsecs;
INIT_STRUCT			gInit;
EHHANDLE    g_hAPI;
SlaveRef	g_SlvRef = { 0 };
uint16_t	g_MainSts[4] = { 0 };
uint16_t	g_SubSts[4] = { 0 };
char		g_AxName_t[5][10] = { "AXIS_X", "AXIS_Y", "AXIS_Z", "AXIS_U" };	// 
uint16_t	g_MotionSeq = MOTION_SEQ_NONE;

// AvP[VR}h
char cCmdSet[30][10] = { "none", "mv", "cir", "jog", "hm", "stp", "r", "help", "quit", "exit"};
// [VԖ
char cMotionSeqName[30][15] = { "none", "", "~", "~()", "쒆", "쒆()", "슮", "I", "G[" };
uint16_t r_msts[4] = { 0 };	// eCXe[^Xi[
uint16_t r_ssts[4] = { 0 };	// eTuXe[^Xi[

// EtherCAT State Machine`FW
BOOL StateChange(uint16_t state, uint16_t count)
{
	uint16_t		woStatus;
	uint16_t		woNowState;		// }X^[݂̌̑Jڏ
	uint8_t			byCntState = 0;	// }X^[̑JڏԊmF

	// NGXg
	woStatus = EhRqState(g_hAPI, state);
	if (woStatus != 0) {
		printf("EhRqState() failed. Status = %04xH\n", woStatus);
		return FALSE;
	}
	// vXe[g֑Jڂǂ̊mF
	while (byCntState <= count) {
		// RSI-ECAT-Master API : ݂̃}X^[̃Xe[gԎ擾
		woStatus = EhGetState(g_hAPI, &state, &woNowState);
		if (woNowState == state) { // Jڊ 
			printf("State Change : Done\n");
			break; // Jڊ̈ڲ
		}
		// Check Time Out
		if (byCntState > count) {
			return FALSE;
			printf("State Change : TimeOut\n");
		}
		// ðݼޑҋ@pذ
		RtSleep(500);
		byCntState++;
	}
	return TRUE;
}

// [VV[PX̎擾
uint16_t getMotionSeq()
{
	uint16_t seq = 0;

	uint32_t dwStatus = WaitForRtSemaphore(gInit.hExclSem, 1, WAIT_FOREVER);
	if (!dwStatus)
	{
		seq = g_MotionSeq;
		ReleaseRtSemaphore(gInit.hExclSem, 1);
	}
	return seq;
}

// R}hp[^̃Zbg
void setCommand(uint16_t cmd)
{
	// CXbhƂ̔r
	uint32_t dwStatus = WaitForRtSemaphore(gInit.hExclSem, 1, WAIT_FOREVER);
	if (!dwStatus)
	{
		g_setCmd = cmd;
		ReleaseRtSemaphore(gInit.hExclSem, 1);
	}
}

// 1̍Ww肵Ĉʒu p[^Zbg
void setMoveParam(uint16_t move_ax, int32_t distnc)
{
	uint32_t dwStatus = WaitForRtSemaphore(gInit.hExclSem, 1, WAIT_FOREVER);
	if (!dwStatus)
	{
		g_MoveAxis = move_ax;
		g_Dist = distnc;
		ReleaseRtSemaphore(gInit.hExclSem, 1);
	}
}

// R}h̕\
void DispCommand()
{
	printf("---------------------------------------------------------------------\n");
	printf(" 1̍Ww肵Ĉʒu : mv,    2̉~ʕ   : cir \n");
	printf(" JOG(S)               : jog,   _A(S)  : hm \n");
	printf(" ~(S)                  : stp,   Xe[^XǏo  : r \n");
	printf(" wv\                  : help,  I        : quit \n");
	printf(" I                    : exit\n");
	printf("---------------------------------------------------------------------\n");
}

// ̃CETuXe[^XƁA[VV[PX̏ԕ\
void DispStatus(uint16_t seq)
{
	// Xe[^X擾
	if (!WaitForRtSemaphore(gInit.hExclSem, 1, WAIT_FOREVER))
	{
		for (int ax = 0; ax < 4; ax++) {
			r_msts[ax] = g_MainSts[ax];
			r_ssts[ax] = g_SubSts[ax];
		}
		ReleaseRtSemaphore(gInit.hExclSem, 1);
	}

	// \
	printf("Slave Num : %x %s\n", g_SlvRef.slave, cMotionSeqName[seq]);
	for (int ax = 0; ax < 4; ax++) 
	{
		printf("%s MainSts : 0x%x, SubSts : 0x%x\n", g_AxName_t[ax], r_msts[ax], r_ssts[ax]);
	}
}

/*****************************************************************************
* FUNCTION:     main
*
* DESCRIPTION:
*  ̓CvOW[ł
*  LAׂẴXbhAׂẴIuWFNg𐶐܂
*  main֐I܂ł̊ԃvZXƂđ݂AIɂׂ̂Ă͍폜܂
\*****************************************************************************/
int					main(int argc, char* argv[])
{
	uint16_t		woStatus;		// RSI-ECAT-Master API ̖߂l
	uint32_t		ret;			// CuAPI̖߂l

	SYSINFO			sysinfo;
#ifdef _DEBUG
	fprintf(stderr, "INtimeTest started\n");
#endif

	// [gvZX擾is܂j
	hRootProcess	= GetRtThreadHandles(ROOT_PROCESS);

	// W[\̂NA܂
	memset(&gInit, 0, sizeof(gInit));
	gInit.state		= BEFORE_INIT;

	// ჌xeBbNli}CNbj擾܂
	if (!CopyRtSystemInfo(&sysinfo))
		Fail("Cannot copy system info");
	dwKtickInUsecs	= 10000 / sysinfo.KernelTickRatio;
	if (dwKtickInUsecs == 0)
		Fail("Invalid low level tick length");

	// vZXővCIeB𒲐܂(s͖)
	// TODO adjust 2Ԗڂ̃p[^𐔒lIɏ邱Ƃł荂vCIeBXbhe܂
	SetRtProcessMaxPriority(NULL_RTHANDLE, 150);

	// CXbh(̊֐)̃nh擾܂
	gInit.hMain		= GetRtThreadHandles(THIS_THREAD);
	gInit.state		= INIT_BUSY;

	// XbhJ^O݂܂As͖܂
	Catalog(NULL_RTHANDLE, gInit.hMain, "TMain");

	// [gvZXɖ{vZXJ^O܂
	if (!Catalog(hRootProcess, GetRtThreadHandles(THIS_PROCESS), "INtimeTest"))
		Fail("Cannot catalog process name");
	gInit.bCataloged = TRUE;

	// rp̃Z}tH
	gInit.hExclSem = CreateRtSemaphore(1, 1, FIFO_QUEUING);
	if (BAD_RTHANDLE == gInit.hExclSem)
	{
		Fail("Cannot create semaphore hExclSem");
	}
	if (!Catalog(NULL_RTHANDLE, gInit.hExclSem, "ExclusiveSem"))
	{
		Fail("Cannot catalog semaphore hExclSem");
	}

	// Ƃ܂
	gInit.state		= INIT_DONE;
#ifdef _DEBUG
	fprintf(stderr, "INtimeTest finished initialization\n");
#endif

	// RSI-ECAT-Master API : RSI-ECAT N
	woStatus = EhGetEhNodeStatus("NodeA", 100);
	printf("EhGetEhNodeStatus() Status = %04xH\n\n", woStatus);
	if (0 != woStatus) {
		Fail("start check failed\n");
		Cleanup();
	}

	// RSI-ECAT-Master API : APIΘbOPEN 
	printf("EtherCAT Master Openc\n");
	g_hAPI = EhOpen("NodeA", &woStatus);
	if (g_hAPI == 0) {
		Fail("EH Handle Open failed. Status = %04xH\n", woStatus);
		Cleanup();
	}
	printf("EtherCAT Master Opened!!\n\n\n");

	// Operational܂őJڂ
	BOOL done_f = FALSE;
	printf("EtherCAT Master Xe[g`FWJn...\n\n");
	printf("Change State INIT ...\n");
	if ((done_f = StateChange(MST_INIT, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}
	printf("Change State PRE_OPE ...\n");
	if ((done_f = StateChange(MST_PRE_OPERATIONAL, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}
	printf("Change State SAFE_OPE ...\n");
	if ((done_f = StateChange(MST_SAFE_OPERATIONAL, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}
	printf("Change State OPE ...\n\n");
	if ((done_f = StateChange(MST_OPERATIONAL, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}

	// CX^Xԍ0ŃX[uEo^
	ret = hic400_GetSlaveInfo(g_hAPI, 0, &g_SlvRef);
	if (ret != 0) {
		Fail("hic400_GetSlaveInfo failed : %x\n", ret);
		EhClose(g_hAPI);
		Cleanup();
	}

	if (BAD_RTHANDLE == CreateRtThread(149, (LPPROC)motion_thread, 4096 * 2, 0)) { // 1FvCIeB́Amain֐
		Fail("[VXbhɎs܂AI܂B\n");
		EhClose(g_hAPI);
		Cleanup();
	}
	
	char		combuf[256] = { 0 };	// L[{[h̃R}h
	size_t		t_length = 0;			// R}h͕
	char		c_move_ax[256] = { 0 };	// L[{[h̎w莲
	uint16_t	move_ax;
	char		c_distnc[256] = { 0 };	// L[{[h̖ڕWʒu
	int32_t		distnc;
	uint32_t	dwCmd = 0;				// R}hԍ
	uint16_t	seq = 0;				// [VV[PXԍ
	BOOL		quit_f = FALSE;			// ItO

	// X[u҂
	printf("X[u...\n");
	while (1) {
		seq = getMotionSeq();
		if (seq == MOTION_SEQ_ERROR) { // G[ŏI
			printf("X[usAI܂B\n");
			EhClose(g_hAPI);
			Cleanup();
		}
		else if (seq == MOTION_SEQ_DONE) {
			printf("X[u\n\n");
			break;
		}
		knRtSleep(1);
	}

	DispCommand(); // R}h\

	// [VJn       
	while (quit_f == FALSE)
	{
		// L[{[h̃R}h͑҂
		printf("Input Command > ");
		if (fgets(combuf, 256, stdin) == '\0' || combuf[0] == '\n') {
			printf("Iregal command\n");
		}
		else
		{
			t_length = strlen(combuf);
			if (combuf[t_length - 1] == '\n') {
				combuf[--t_length] = '\0';
			}
			dwCmd = 0xFFFF;
			// ̓R}h
			for (int i = 0; i < 30; i++) {
				if (strcmp(combuf, cCmdSet[i]) == 0) {
					dwCmd = i;
					break;
				}
			}
			seq = getMotionSeq(); // [VV[PX擾
			if (seq == MOTION_SEQ_ERROR) // G[ȂI
				break;

			switch (dwCmd) // R}hƂ̏
			{
			case app_cmd_move:
				if (seq == MOTION_SEQ_DONE) // 슮̂ݎs\
				{
					printf("Input Axis Number(X=1, Y=2, Z=3, U=4) >"); // 쎲w
					fgets(c_move_ax, 256, stdin);
					move_ax = atoi(c_move_ax);
					if (move_ax < 1 || move_ax > 4) {
						printf("Iregal Axis\n");
						break;
					}
					move_ax = move_ax - 1;
					printf("Input Target Position > "); // ڕWʒuw
					fgets(c_distnc, 256, stdin);
					distnc = atoi(c_distnc);
					setMoveParam(move_ax, distnc); // p[^Zbg
					setCommand(dwCmd); // R}hZbg
				}
				else {
					printf("쒆łB~ɎsĂB\n");
				}
				break;
			case app_cmd_circle:
				if (seq == MOTION_SEQ_DONE) // 슮̂ݎs\
					setCommand(dwCmd); // R}hZbg
				else 
					printf("쒆łB~ɎsĂB\n");
				break;
			case app_cmd_jog:
				if (seq == MOTION_SEQ_DONE) // 슮̂ݎs\
					setCommand(dwCmd); // R}hZbg
				else 
					printf("쒆łB~ɎsĂB\n");
				break;
			case app_cmd_home:
				if (seq == MOTION_SEQ_DONE) // 슮̂ݎs\
					setCommand(dwCmd); // R}hZbg
				else 
					printf("쒆łB~ɎsĂB\n");
				break;
			case app_cmd_stop:
				if (seq == MOTION_SEQ_MOVING || seq == MOTION_SEQ_CIRCLE)	// 쒆̂ݎs\
					setCommand(dwCmd); // R}hZbg
				else
					printf("~łB쒆ɎsĂB\n");
				break;
			case app_cmd_h: // wv\
				DispCommand();
				break;
			case app_cmd_r: // Xe[^X\
				DispStatus(seq);
				break;
			case app_cmd_q: // I
				if (seq == MOTION_SEQ_DONE) { // 슮̂ݎs\
					setCommand(dwCmd); // R}hZbg
					quit_f = TRUE;
					printf("I...\n");
					RtSleep(3000);
				}
				else
					printf("쒆łB~ɎsĂB\n");
				break;
			case app_cmd_e: // I
				setCommand(dwCmd); // R}hZbg
				quit_f = TRUE;
				break;
			default:
				printf("Iregal command\n");
				break;
			}
		}
	}

	// Init܂őJڂ
	done_f = FALSE;
	printf("EtherCAT Master Xe[g`FWJn...\n\n");
	printf("Change State SAFE_OPE ...\n");
	if ((done_f = StateChange(MST_SAFE_OPERATIONAL, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}
	printf("Change State PRE_OP ...\n");
	if ((done_f = StateChange(MST_PRE_OPERATIONAL, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}
	printf("Change State INIT ...\n");
	if ((done_f = StateChange(MST_INIT, 60)) == FALSE) {
		printf("State Change failed ...\n");
		EhClose(g_hAPI);
		Cleanup();
	}

	woStatus = EhClose(g_hAPI);
	if (woStatus != 0) {
		Fail("EH Handle Close failed\n");
	}

	printf("AvP[VI܂\n");
	return 0;
}